/***************************************************************************
                          Ahoj.cpp  -  description
                             -------------------
    begin                : St kv 12 2004
    copyright            : (C) 2004 by Petr Kavanek
    email                : pietrotk@seznam.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "Ahoj.h"

#include <iostream>
#include <string>

// nezbytna globalni instance teto tridy
T_AhojSveteApp AhojSveteApp;


//---------------------------------------------------------------------------
// main()
//---------------------------------------------------------------------------
int T_AhojSveteApp::main(int argc, char** argv) {

  using namespace std;

  // vytvorime okno konzole kvuli textovemu vystupu jako
  // jsou zpravy o chybach
  CL_ConsoleWindow Console("Konzole");

  // presmerujeme na konsoli standardni vstup a vystup
  Console.redirect_stdio();

  try {

    // nutna inicializace pouzivanych casti knihovny
    CL_SetupCore::init();
    CL_SetupDisplay::init();
    CL_SetupGL::init();

    // vytvorime okno 640 x 480 pixelu s titulkem Ahoj, Svete!
    const string Titulek = "Ahoj, Svete!";
    const int SirkaOkna = 640;
    const int VyskaOkna = 480;
    const bool FullScreen = false;    
    CL_DisplayWindow NaseOkno(Titulek, SirkaOkna, VyskaOkna, FullScreen);

    // vytvorime obrazek (logo knihovny ClanLib)
    const string CestaKObrazku = "clanlib.png";
    CL_Surface Logo(CestaKObrazku);

    // souradnice Loga
    const int LogoX = 170;
    const int LogoY = 180;

    // pockame si na stisteni klavesy escape
    while (! CL_Keyboard::get_keycode(CL_KEY_ESCAPE)) {

      // invariant: Dosud nebyl stisten escape pri get_keycode() 
      
      // vyplnime okno cernou barvou
      CL_Display::clear(CL_Color::black);

      // vykreslime logo, souradnice udavaji polohu leveho horniho rohu
      Logo.draw(LogoX, LogoY);

      // zobrazime nakreslene zmeny (prehozeni predniho a zadniho bufferu)
      CL_Display::flip();


      // uspime aplikaci na deset milisekund, abychom zbytecne
      // neblokovali procesor
      const int DobaObnoveni = 10;
      CL_System::sleep(DobaObnoveni);
      
      // probudime aplikaci resp. knihovnu aby byla aktualni
      CL_System::keep_alive();

    } // while

    // deinicializujeme drive inicializovane casti knihovny
    CL_SetupGL::deinit();
    CL_SetupDisplay::deinit();
    CL_SetupCore::deinit();

  } // try
  catch (CL_Error Chyba) {

    cout << "Zachycena chyba: " << Chyba.message.c_str() << endl;

    // zavreme okno konzole a pockame na stisteni klavesy
    Console.display_close_message();

    // ukoncime aplikaci, jedna signalizuje neuspech
    return 1;

  } // catch

  // ukoncime nasi aplikaci, nula signalizuje uspech
  return 0;
    
} // main() -----------------------------------------------------------------
  

  

  